#!/usr/bin/env python
import re
from isstring import isstring
from public import public


@public
def iswildcard(string):
    """Check string is Unix shell-style wildcards

    Returns:
        true if string is pattern, false else
    """
    # https://docs.python.org/2/library/fnmatch.html
    if not string:
        return False
    if not isstring(string):
        return False
    if "*" in string:
        return True
    if "?" in string:
        return True
    if bool(re.match('(.*)\[([^]]*)\](.*)', string)):
        # [seq]
        return True
    if bool(re.match('(.*)\[\!([^]]*)\](.*)', string)):
        # [!seq]
        return True
    return False
